import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
/** @jsxImportSource @emotion/react */
import * as React from "react";
import { animate, motion, useMotionValue, } from "framer-motion";
import { useMMenuBarOcup } from "./MainMenuBar";
const pageStyle = {
    display: "inline-block",
    flex: "none",
};
const containerStyle = {
    position: "relative",
    width: "100%",
    height: "100%",
    overflowX: "hidden",
    display: "flex",
};
const transition = {
    type: "spring",
    bounce: 0,
};
const Contaier = React.forwardRef((props, ref) => (_jsx("div", { ref: ref, style: containerStyle, children: props.children })));
export const TwoHalfCarousel = ({ children, carousel = false, value: index = 0, onRequestChange: setIndex, }) => {
    const containerRef = React.useRef(null);
    const x = useMotionValue(0);
    // const [index, setIndex] = React.useState(0)
    const calculateNewX = React.useCallback(() => -index * (containerRef.current?.clientWidth || 0), [index]);
    const handleEndDrag = (e, dragProps) => {
        const clientWidth = containerRef.current?.clientWidth || 0;
        const { offset, velocity } = dragProps;
        const xDrag = Math.abs(velocity.x) > Math.abs(velocity.y);
        if (!xDrag) {
            return animate(x, calculateNewX(), transition);
        }
        if (offset.x > clientWidth / 4) {
            handlePrev();
        }
        else if (offset.x < -clientWidth / 4) {
            handleNext();
        }
        else {
            animate(x, calculateNewX(), transition);
        }
    };
    const childrens = React.Children.toArray(children);
    const handleNext = () => {
        const toIndex = (index + 1) >= childrens.length ? 0 : (index + 1);
        setIndex(toIndex);
    };
    //原地踏步吗：true。
    const handlePrev = () => {
        const toIndex = (index - 1 < 0) ? (childrens.length - 1) : (index - 1);
        setIndex(toIndex);
    };
    React.useEffect(() => {
        const controls = animate(x, calculateNewX(), transition);
        return controls.stop;
    }, [calculateNewX, index, x]);
    const { barHeight, bottomCss } = useMMenuBarOcup(false);
    return (_jsxs(Contaier, { ref: containerRef, children: [_jsx(motion.div, { style: {
                    ...pageStyle,
                    x,
                    left: `0%`,
                    right: `0%`,
                    width: carousel ? "100%" : "60%",
                    // minHeight:  `calc(100vh - ${barHeight})`,
                }, css: {
                    height: `calc(100vh - ${barHeight})`,
                    overflowY: 'auto',
                }, drag: carousel ? "x" : false, dragElastic: 0.3, onDragEnd: handleEndDrag, dragDirectionLock: true, children: childrens[0] }, 1), _jsx(motion.div, { style: {
                    ...pageStyle,
                    x,
                    left: `100%`,
                    right: `100%`,
                    width: carousel ? "100%" : "40%",
                    // minHeight: carousel? `calc(100vh - ${barHeight})` : 'unset',
                }, css: {
                    height: carousel ? `calc(100vh - ${barHeight})` : '100%',
                }, drag: carousel ? "x" : false, dragElastic: 0.3, onDragEnd: handleEndDrag, dragDirectionLock: true, children: childrens[1] }, 2)] }));
};
//# sourceMappingURL=TwoHalfCarousel.js.map